from rocolib.api.components.Component import Component

c = Component()

# BOX

c.addSubcomponent("boat","BoatBase", inherit=True, prefix=None, root=True)

c.addParameter("seats", 3, paramType="count", minValue=1, maxValue=10)

c.addSubcomponent("portsplit","SplitEdge")
c.addSubcomponent("starsplit","SplitEdge")

c.addConstraint(("portsplit","botlength"), ("boat.length", "seats"), "(x[0],)")
c.addConstraint(("portsplit","toplength"), ("boat.length", "seats"), "(x[0]/(2.*x[1]+1.),) * (2*x[1]+1)")
c.addConstraint(("starsplit","toplength"), ("boat.length", "seats"), "(x[0],)")
c.addConstraint(("starsplit","botlength"), ("boat.length", "seats"), "(x[0]/(2.*x[1]+1.),) * (2*x[1]+1)")

c.addConnection(("portsplit", "botedge0"), ("boat", "portedge"), angle=90)
c.addConnection(("starsplit", "topedge0"), ("boat", "staredge"), angle=90, tabWidth=10)

for i in range(10):
    nm = "seat%d"%i
    c.addSubcomponent(nm, "Rectangle")
    c.addConstraint((nm, "l"), ("boat.width", "seats"), "(%d < x[1]) and x[0] or 0" % i)
    c.addConstraint((nm, "w"), ("boat.length", "seats"), "x[0]/(2.*x[1]+1.)")
    c.addConnection(("portsplit", "topedge%d" % (2*i+1)), (nm, "l"))
    c.addConnection(("starsplit", "botedge%d" % (2*i+1)), (nm, "r"))

c.toLibrary("Canoe")
